// Code generated by gotdgen, DO NOT EDIT.

package tdapi

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// SetGroupCallTitleRequest represents TL type `setGroupCallTitle#b6c19dcd`.
type SetGroupCallTitleRequest struct {
	// Group call identifier
	GroupCallID int32
	// New group call title; 1-64 characters
	Title string
}

// SetGroupCallTitleRequestTypeID is TL type id of SetGroupCallTitleRequest.
const SetGroupCallTitleRequestTypeID = 0xb6c19dcd

// Ensuring interfaces in compile-time for SetGroupCallTitleRequest.
var (
	_ bin.Encoder     = &SetGroupCallTitleRequest{}
	_ bin.Decoder     = &SetGroupCallTitleRequest{}
	_ bin.BareEncoder = &SetGroupCallTitleRequest{}
	_ bin.BareDecoder = &SetGroupCallTitleRequest{}
)

func (s *SetGroupCallTitleRequest) Zero() bool {
	if s == nil {
		return true
	}
	if !(s.GroupCallID == 0) {
		return false
	}
	if !(s.Title == "") {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (s *SetGroupCallTitleRequest) String() string {
	if s == nil {
		return "SetGroupCallTitleRequest(nil)"
	}
	type Alias SetGroupCallTitleRequest
	return fmt.Sprintf("SetGroupCallTitleRequest%+v", Alias(*s))
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*SetGroupCallTitleRequest) TypeID() uint32 {
	return SetGroupCallTitleRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*SetGroupCallTitleRequest) TypeName() string {
	return "setGroupCallTitle"
}

// TypeInfo returns info about TL type.
func (s *SetGroupCallTitleRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "setGroupCallTitle",
		ID:   SetGroupCallTitleRequestTypeID,
	}
	if s == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "GroupCallID",
			SchemaName: "group_call_id",
		},
		{
			Name:       "Title",
			SchemaName: "title",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (s *SetGroupCallTitleRequest) Encode(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't encode setGroupCallTitle#b6c19dcd as nil")
	}
	b.PutID(SetGroupCallTitleRequestTypeID)
	return s.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (s *SetGroupCallTitleRequest) EncodeBare(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't encode setGroupCallTitle#b6c19dcd as nil")
	}
	b.PutInt32(s.GroupCallID)
	b.PutString(s.Title)
	return nil
}

// Decode implements bin.Decoder.
func (s *SetGroupCallTitleRequest) Decode(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't decode setGroupCallTitle#b6c19dcd to nil")
	}
	if err := b.ConsumeID(SetGroupCallTitleRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode setGroupCallTitle#b6c19dcd: %w", err)
	}
	return s.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (s *SetGroupCallTitleRequest) DecodeBare(b *bin.Buffer) error {
	if s == nil {
		return fmt.Errorf("can't decode setGroupCallTitle#b6c19dcd to nil")
	}
	{
		value, err := b.Int32()
		if err != nil {
			return fmt.Errorf("unable to decode setGroupCallTitle#b6c19dcd: field group_call_id: %w", err)
		}
		s.GroupCallID = value
	}
	{
		value, err := b.String()
		if err != nil {
			return fmt.Errorf("unable to decode setGroupCallTitle#b6c19dcd: field title: %w", err)
		}
		s.Title = value
	}
	return nil
}

// EncodeTDLibJSON implements tdjson.TDLibEncoder.
func (s *SetGroupCallTitleRequest) EncodeTDLibJSON(b tdjson.Encoder) error {
	if s == nil {
		return fmt.Errorf("can't encode setGroupCallTitle#b6c19dcd as nil")
	}
	b.ObjStart()
	b.PutID("setGroupCallTitle")
	b.Comma()
	b.FieldStart("group_call_id")
	b.PutInt32(s.GroupCallID)
	b.Comma()
	b.FieldStart("title")
	b.PutString(s.Title)
	b.Comma()
	b.StripComma()
	b.ObjEnd()
	return nil
}

// DecodeTDLibJSON implements tdjson.TDLibDecoder.
func (s *SetGroupCallTitleRequest) DecodeTDLibJSON(b tdjson.Decoder) error {
	if s == nil {
		return fmt.Errorf("can't decode setGroupCallTitle#b6c19dcd to nil")
	}

	return b.Obj(func(b tdjson.Decoder, key []byte) error {
		switch string(key) {
		case tdjson.TypeField:
			if err := b.ConsumeID("setGroupCallTitle"); err != nil {
				return fmt.Errorf("unable to decode setGroupCallTitle#b6c19dcd: %w", err)
			}
		case "group_call_id":
			value, err := b.Int32()
			if err != nil {
				return fmt.Errorf("unable to decode setGroupCallTitle#b6c19dcd: field group_call_id: %w", err)
			}
			s.GroupCallID = value
		case "title":
			value, err := b.String()
			if err != nil {
				return fmt.Errorf("unable to decode setGroupCallTitle#b6c19dcd: field title: %w", err)
			}
			s.Title = value
		default:
			return b.Skip()
		}
		return nil
	})
}

// GetGroupCallID returns value of GroupCallID field.
func (s *SetGroupCallTitleRequest) GetGroupCallID() (value int32) {
	if s == nil {
		return
	}
	return s.GroupCallID
}

// GetTitle returns value of Title field.
func (s *SetGroupCallTitleRequest) GetTitle() (value string) {
	if s == nil {
		return
	}
	return s.Title
}

// SetGroupCallTitle invokes method setGroupCallTitle#b6c19dcd returning error if any.
func (c *Client) SetGroupCallTitle(ctx context.Context, request *SetGroupCallTitleRequest) error {
	var ok Ok

	if err := c.rpc.Invoke(ctx, request, &ok); err != nil {
		return err
	}
	return nil
}
