// Code generated by gotdgen, DO NOT EDIT.

package tg

import (
	"context"
	"errors"
	"fmt"
	"sort"
	"strings"

	"go.uber.org/multierr"

	"github.com/gotd/td/bin"
	"github.com/gotd/td/tdjson"
	"github.com/gotd/td/tdp"
	"github.com/gotd/td/tgerr"
)

// No-op definition for keeping imports.
var (
	_ = bin.Buffer{}
	_ = context.Background()
	_ = fmt.Stringer(nil)
	_ = strings.Builder{}
	_ = errors.Is
	_ = multierr.AppendInto
	_ = sort.Ints
	_ = tdp.Format
	_ = tgerr.Error{}
	_ = tdjson.Encoder{}
)

// MessagesToggleBotInAttachMenuRequest represents TL type `messages.toggleBotInAttachMenu#1aee33af`.
//
// See https://core.telegram.org/method/messages.toggleBotInAttachMenu for reference.
type MessagesToggleBotInAttachMenuRequest struct {
	//
	Bot InputUserClass
	//
	Enabled bool
}

// MessagesToggleBotInAttachMenuRequestTypeID is TL type id of MessagesToggleBotInAttachMenuRequest.
const MessagesToggleBotInAttachMenuRequestTypeID = 0x1aee33af

// Ensuring interfaces in compile-time for MessagesToggleBotInAttachMenuRequest.
var (
	_ bin.Encoder     = &MessagesToggleBotInAttachMenuRequest{}
	_ bin.Decoder     = &MessagesToggleBotInAttachMenuRequest{}
	_ bin.BareEncoder = &MessagesToggleBotInAttachMenuRequest{}
	_ bin.BareDecoder = &MessagesToggleBotInAttachMenuRequest{}
)

func (t *MessagesToggleBotInAttachMenuRequest) Zero() bool {
	if t == nil {
		return true
	}
	if !(t.Bot == nil) {
		return false
	}
	if !(t.Enabled == false) {
		return false
	}

	return true
}

// String implements fmt.Stringer.
func (t *MessagesToggleBotInAttachMenuRequest) String() string {
	if t == nil {
		return "MessagesToggleBotInAttachMenuRequest(nil)"
	}
	type Alias MessagesToggleBotInAttachMenuRequest
	return fmt.Sprintf("MessagesToggleBotInAttachMenuRequest%+v", Alias(*t))
}

// FillFrom fills MessagesToggleBotInAttachMenuRequest from given interface.
func (t *MessagesToggleBotInAttachMenuRequest) FillFrom(from interface {
	GetBot() (value InputUserClass)
	GetEnabled() (value bool)
}) {
	t.Bot = from.GetBot()
	t.Enabled = from.GetEnabled()
}

// TypeID returns type id in TL schema.
//
// See https://core.telegram.org/mtproto/TL-tl#remarks.
func (*MessagesToggleBotInAttachMenuRequest) TypeID() uint32 {
	return MessagesToggleBotInAttachMenuRequestTypeID
}

// TypeName returns name of type in TL schema.
func (*MessagesToggleBotInAttachMenuRequest) TypeName() string {
	return "messages.toggleBotInAttachMenu"
}

// TypeInfo returns info about TL type.
func (t *MessagesToggleBotInAttachMenuRequest) TypeInfo() tdp.Type {
	typ := tdp.Type{
		Name: "messages.toggleBotInAttachMenu",
		ID:   MessagesToggleBotInAttachMenuRequestTypeID,
	}
	if t == nil {
		typ.Null = true
		return typ
	}
	typ.Fields = []tdp.Field{
		{
			Name:       "Bot",
			SchemaName: "bot",
		},
		{
			Name:       "Enabled",
			SchemaName: "enabled",
		},
	}
	return typ
}

// Encode implements bin.Encoder.
func (t *MessagesToggleBotInAttachMenuRequest) Encode(b *bin.Buffer) error {
	if t == nil {
		return fmt.Errorf("can't encode messages.toggleBotInAttachMenu#1aee33af as nil")
	}
	b.PutID(MessagesToggleBotInAttachMenuRequestTypeID)
	return t.EncodeBare(b)
}

// EncodeBare implements bin.BareEncoder.
func (t *MessagesToggleBotInAttachMenuRequest) EncodeBare(b *bin.Buffer) error {
	if t == nil {
		return fmt.Errorf("can't encode messages.toggleBotInAttachMenu#1aee33af as nil")
	}
	if t.Bot == nil {
		return fmt.Errorf("unable to encode messages.toggleBotInAttachMenu#1aee33af: field bot is nil")
	}
	if err := t.Bot.Encode(b); err != nil {
		return fmt.Errorf("unable to encode messages.toggleBotInAttachMenu#1aee33af: field bot: %w", err)
	}
	b.PutBool(t.Enabled)
	return nil
}

// Decode implements bin.Decoder.
func (t *MessagesToggleBotInAttachMenuRequest) Decode(b *bin.Buffer) error {
	if t == nil {
		return fmt.Errorf("can't decode messages.toggleBotInAttachMenu#1aee33af to nil")
	}
	if err := b.ConsumeID(MessagesToggleBotInAttachMenuRequestTypeID); err != nil {
		return fmt.Errorf("unable to decode messages.toggleBotInAttachMenu#1aee33af: %w", err)
	}
	return t.DecodeBare(b)
}

// DecodeBare implements bin.BareDecoder.
func (t *MessagesToggleBotInAttachMenuRequest) DecodeBare(b *bin.Buffer) error {
	if t == nil {
		return fmt.Errorf("can't decode messages.toggleBotInAttachMenu#1aee33af to nil")
	}
	{
		value, err := DecodeInputUser(b)
		if err != nil {
			return fmt.Errorf("unable to decode messages.toggleBotInAttachMenu#1aee33af: field bot: %w", err)
		}
		t.Bot = value
	}
	{
		value, err := b.Bool()
		if err != nil {
			return fmt.Errorf("unable to decode messages.toggleBotInAttachMenu#1aee33af: field enabled: %w", err)
		}
		t.Enabled = value
	}
	return nil
}

// GetBot returns value of Bot field.
func (t *MessagesToggleBotInAttachMenuRequest) GetBot() (value InputUserClass) {
	if t == nil {
		return
	}
	return t.Bot
}

// GetEnabled returns value of Enabled field.
func (t *MessagesToggleBotInAttachMenuRequest) GetEnabled() (value bool) {
	if t == nil {
		return
	}
	return t.Enabled
}

// MessagesToggleBotInAttachMenu invokes method messages.toggleBotInAttachMenu#1aee33af returning error if any.
//
// See https://core.telegram.org/method/messages.toggleBotInAttachMenu for reference.
// Can be used by bots.
func (c *Client) MessagesToggleBotInAttachMenu(ctx context.Context, request *MessagesToggleBotInAttachMenuRequest) (bool, error) {
	var result BoolBox

	if err := c.rpc.Invoke(ctx, request, &result); err != nil {
		return false, err
	}
	_, ok := result.Bool.(*BoolTrue)
	return ok, nil
}
